#include "winmain.h"



extern int g_window_width;
extern int g_window_height;

extern int g_multiview_mode;

extern double g_epsAtomSize;
extern double g_epsBondSize;
extern double g_epsBoxLineSize;


extern int g_gpu_DX11;

extern int g_vsync_mode;

extern int g_visual_atom;
extern int g_visual_atomcolor; 
extern double g_visual_atomradius;
extern int g_visual_bond;
extern int g_visual_traj;
extern int g_visual_atompoly;
extern int g_visual_bondpoly;
extern double g_visual_trajparticleRadius;
extern float g_visual_trajcolor[3];
extern int g_visual_box;

extern int g_periodic;
extern mat33f g_default_boxaxis;


double _GetPrivateProfileDouble(LPCTSTR lpAppName, LPCTSTR lpKeyName, double defaultVal, LPCTSTR lpFileName);
int _GetPrivateProfileFloatArray(LPCTSTR lpAppName, LPCTSTR lpKeyName, LPCTSTR lpDefaultArray, float* farray, LPCTSTR lpFileName);



int LoadSettingFile(const TCHAR* filename){
	
	//ݒt@C̃tpX̎擾.
	/*
	TCHAR filepath[MAX_PATH];
	int length = GetModuleFileName(NULL, filepath, MAX_PATH);
	if(length <= 0){ return -1;}

	TCHAR* p = _tcsrchr(filepath, _T('\\'));
	if(! p ) { return -1;}

	_tcscpy(p + 1, filename);
	*/
	TCHAR filepath[MAX_PATH];
	SetModuleDirPath(filename, filepath);


	//ǂݏo//
	
	g_gpu_DX11 = GetPrivateProfileInt(_T("GPUDriver"), _T("DirectX11"), 0, filepath);
	g_vsync_mode = GetPrivateProfileInt(_T("GPUDriver"), _T("Vsync"), 1, filepath);	//0:ɕ`,1:,2:Kv̂.
	
	g_window_width = GetPrivateProfileInt(_T("WINDOW"), _T("Width"), 1024, filepath);
	g_window_height = GetPrivateProfileInt(_T("WINDOW"), _T("Height"), 768, filepath);
	
	g_epsAtomSize = _GetPrivateProfileDouble(_T("EPS"), _T("AtomSize"), 1.0, filepath);
	g_epsBondSize = _GetPrivateProfileDouble(_T("EPS"), _T("BondSize"), 0.5, filepath);
	g_epsBoxLineSize = _GetPrivateProfileDouble(_T("EPS"), _T("BoxLineSize"), 0.5, filepath);
	

	
	g_visual_atom = GetPrivateProfileInt(_T("VISUAL"), _T("Atom"), 1, filepath);
	g_visual_atompoly = GetPrivateProfileInt(_T("VISUAL"), _T("AtomPoly"), 4, filepath);
	g_visual_atomcolor = GetPrivateProfileInt(_T("VISUAL"), _T("AtomColor"), 0, filepath);
	g_visual_atomradius = _GetPrivateProfileDouble(_T("VISUAL"), _T("AtomRadius"), 0.25, filepath);
	g_visual_bond = GetPrivateProfileInt(_T("VISUAL"), _T("Bond"), 1, filepath);
	g_visual_bondpoly = GetPrivateProfileInt(_T("VISUAL"), _T("BondPoly"), 8, filepath);
	
	g_visual_trajparticleRadius = _GetPrivateProfileDouble(_T("VISUAL"), _T("TrajectoryParticleRadius"), 2.0, filepath);
	_GetPrivateProfileFloatArray(_T("VISUAL"), _T("TrajectoryColor"), _T("1.0,1.0,1.0"), g_visual_trajcolor, filepath);
	
	g_visual_box = GetPrivateProfileInt(_T("VISUAL"), _T("Box"), 0, filepath);

	g_periodic = GetPrivateProfileInt(_T("BASIC"), _T("Periodic"), 0, filepath);

	TCHAR line[1024];
	GetPrivateProfileString(_T("BASIC"), _T("DefaultBox"),
				_T("10.0,0.0,0.0,0.0,10.0,0.0,0.0,0.0,10.0"), line, 1024, filepath);
	TCHAR* tp = _tcstok(line, _T(" ,\t\r\n"));
	for(int i = 0; i < 9; i++){
		g_default_boxaxis.elements[i] = (float)_tcstod(tp, NULL);
		tp = _tcstok(NULL, _T(" ,\t\r\n"));
	}
	
	
	g_multiview_mode = GetPrivateProfileInt(_T("WINDOW"), _T("Multiview"), 1, filepath);

	return 0;

}


double _GetPrivateProfileDouble(LPCTSTR lpAppName, LPCTSTR lpKeyName, double defaultVal, LPCTSTR lpFileName){

	const int bufsz = 1024;
	TCHAR buffer[bufsz];

	GetPrivateProfileString(lpAppName, lpKeyName, _T("S"), buffer, bufsz, lpFileName);
	if (*buffer == _T('S')){
		return defaultVal;
	}else{
		return _tcstod(buffer, NULL);
	}

}

int _GetPrivateProfileFloatArray(LPCTSTR lpAppName, LPCTSTR lpKeyName, LPCTSTR lpDefaultArray, float* farray, LPCTSTR lpFileName){

	const int bufsz = 1024;
	TCHAR buffer[bufsz];

	GetPrivateProfileString(lpAppName, lpKeyName, lpDefaultArray, buffer, bufsz, lpFileName);
	float* p = farray;
	for(TCHAR* tp = _tcstok(buffer,_T(" ,\t")); tp != NULL; tp = _tcstok(NULL,_T(" ,\t")) ){
		*p = (float)_tcstod(tp, NULL);
		p++;
	}
	return (int)(p - farray);
}