// MDLoader.cpp: MDLoader NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include <string.h>
#include <math.h>
#include "MDLoader.h"
#include "io64.h"
#include "renew.h"
#include "mytchar.h"

#include "ai_molecule.h"
#include "md3_reader.h"

#pragma warning(disable : 4996)


#define FAD_FLAG_J		(0x1)		//GlM[f[^.
#define FAD_FLAG_SIMBOX	(0x2)	//simbox̎w肪.
#define FAD_FLAG_NONORTHOGONALBOX	(0x20)	//simbox񒼌ł.
#define FAD_FLAG_TEMPERATURE		(0x4)	//x񂪂.
#define FAD_FLAG_STEP		(0x8)		//int4^step񂪂.
#define FAD_FLAG_ATOMEXT		(0x10)		//qid̔z񂪂.

extern mat33f g_default_boxaxis;


//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

MDLoader::MDLoader(const TCHAR *filename) :
	m_bond_check(0)
{
	
	m_frameNo = 0;

	m_wfp = NULL;
	fp = NULL;

	m_maxAtomCount = 0;
	m_maxBondCount = 0;
	m_flags = 0;

	Load(filename);
	if(!m_framev.empty()){
		m_framev[0].keep = 1;
	}


}


MDLoader::~MDLoader(){
	if(fp){ fclose64(fp);}
	//delete [] stockFPL;
	clearBuffer();

	closeWriteFile();
}



void MDLoader::Load(const TCHAR *filename){
//	nowDat = fstDat = NULL;
	
	//long64 filelen;

	size_t outlen = _tcslen(filename);
	if(_tcscmp(filename + outlen - 4,_T(".dat")) == 0){

		fp = fopen64(filename,_T("rb"));
		if( fp == NULL ){  // ֐sĂȂ
			printf( "t@C̃I[vɎs܂ : %s\n",filename);	
			readMode = -1;
			return;  // ُI͂OȊOԂ
		}
	
		//fseek64(fp, LONG64_ZERO, SEEK_END);
		//filelen = ftell64(fp);

		int mcnt = readBIN(fp, 1);
	//	m_fpos_current = m_fpos_first;
	
	}else if(_tcscmp(filename + outlen - 4,_T(".fad")) == 0){

		fp = fopen64(filename,_T("rb"));
		//fp = _tfopen(filename,_T("rb"));
		if( fp == NULL ){  // ֐sĂȂ
			printf( "t@C̃I[vɎs܂ : %s\n",filename);	
			readMode = -1;
			return;  // ُI͂OȊOԂ
		}
	
		//fseek64(fp, LONG64_ZERO, SEEK_END);
		//filelen = ftell64(fp);

		int mcnt = readBIN(fp, 2);
	//	m_fpos_current = m_fpos_first;

	}else if(_tcscmp(filename + outlen - 4, _T(".pdb")) == 0){
		//eLXg`̂Ƃ
		//64rbgł͓ǂ܂ȂB

		FILE* fp32 = _tfopen(filename,_T("r"));
		if( fp32 == NULL ){  // ֐sĂȂ
			printf( "t@C̃I[vɎs܂ : %s\n",filename);	
			readMode = -1;
			return;  // ُI͂OȊOԂ
		}
	
		int mcnt = readTXT(fp32, 3);
	//	m_fpos_current = m_fpos_first;
		fclose(fp32);
		readMode = 0;
		return;
	}else if((_tcscmp(filename + outlen - 4,_T(".xyz"))==0)||(_tcscmp(filename + outlen - 3,_T(".md")) == 0)){

		FILE* fp32 = _tfopen(filename,_T("r"));
		if( fp32 == NULL ){  // ֐sĂȂ
			printf( "t@C̃I[vɎs܂ : %s\n",filename);	
			readMode = -1;
			return;  // ُI͂OȊOԂ
		}
	
		int mcnt = readTXT(fp32, 4);
	//	m_fpos_current = m_fpos_first;
		fclose(fp32);
		readMode = 0;
		return;
	
	}else if( _tcscmp(filename + outlen - 4,_T(".md2")) == 0){

		FILE* fp32 = _tfopen(filename,_T("r"));
		if( fp32 == NULL ){  // ֐sĂȂ
			printf( "t@C̃I[vɎs܂ : %s\n",filename);	
			readMode = -1;
			return;  // ُI͂OȊOԂ
		}
	
		int mcnt = readTXT(fp32, 5);
	//	m_fpos_current = m_fpos_first;
		fclose(fp32);
		readMode = 0;
		return;
	
	}else if( _tcscmp(filename + outlen - 4,_T(".md3")) == 0){

		
		if(readMD3(filename) < 0){
			printf( "t@C̃I[vɎs܂ : %s\n",filename);	
			readMode = -1;
			return;  // ُI͂OȊOԂ
		}
	
		readMode = 0;
		return;
	}

	
	if(readMode > 0){
	/*	stockCnt = mcnt;
		stockFPL = new FILEPOS_LIST*[stockCnt];
		for(stockIdx = 0; stockIdx < stockCnt; stockIdx++){
			stockFPL[stockIdx] = m_fpos_current;
			m_fpos_current = m_fpos_current->next;
		}
		m_fpos_current = m_fpos_first;
		stockIdx = 0;
		*/
	}else if(readMode == 0){
		fclose64(fp);
		fp=NULL;
		fp_pos = LONG64_FULL;
	}
}


int MDLoader::readBIN(FILE64 *fp, int mode){

//	FILEPOS_LIST* fa;
//	FILEPOS_LIST* fb;
	ATOMS_DATA *a;

	int mcnt;
		
//	fb = NULL;
	mcnt = 0;
	fp_pos = LONG64_ZERO;
	m_unknown_pos = LONG64_ZERO;
	Jmax = -1.0;

	readMode = 0;

	//rewind(fp);
	fseek64(fp, LONG64_ZERO, SEEK_SET);
	
	switch(mode){
	case 1:
		a = readFrameDAT(fp,fp_pos);
		break;
	case 2:
		a = readFrameFAD(fp,fp_pos);
		break;
	default:
		return 0;
	}

	while(a){
		

//		fa = new FILEPOS_LIST;
//		fa->prev = fb;
//		if (fb) {fb->next = fa;}
//		else{m_fpos_first=fa;}

		//fa->atmdat = a;
		if(a->no == -1){ a->no = mcnt;}
		FRAME_POS frame;
		frame.filepos = fp_pos;
		frame.atmdat = a;
		frame.keep = 0;
		m_framev.push_back(frame);
		//fa->pos = fp_pos;
		
		//fb=fa;
		
		//pos = jumplen + sizeof(int) * 3;
		fp_pos = ftell64(fp);
		//printf("model %d, particle %d, bond %d\n",mcnt,pcnt,bcnt);


//		if(mcnt % 1000 == 0 ){	printf("read now %d", mcnt);}
		mcnt ++;

		if(fp_pos > READLIMIT){
			//obt@[t
			//rf̈
			m_unknown_pos = fp_pos;
			readMode = mode;			
			break;
		}

		switch(mode){
		case 1:
			a = readFrameDAT(fp,fp_pos);
			break;
		case 2:
			a = readFrameFAD(fp,fp_pos);
			break;
		}

	}
	//fb->next = NULL;
	//a->prev = b;
	if (m_unknown_pos) {
		//rf
		printf("buffer fulls halfway\n");
	}

	
//	stockCnt = mcnt;
//	stock = new FILEPOS_LIST*[stockCnt];
//	stockIdx = 0;
		
	printf("%d frame loaded\n",mcnt);
//	printf("%d atom exist\n",m_fpos_first->atmdat->pcnt);
	
	return mcnt;
	
}





ATOMS_DATA* MDLoader::readFrameDAT(FILE64* fp, long64 filepos){
	//ǂݍݐFMDLoaderԂ
	//sFNULLԂ
	//t@CI[œǂ߂ȂƂFNULLԂ

	ATOMS_DATA *a = new ATOMS_DATA;
	
	int i;//,j,dmyi;
	int pcnt,bcnt;
	float rr,xx,yy,zz;
	const float bondmax[] = {2.0f*2.0f, 1.8f*1.8f, 1.7f*1.7f};//{1.85*1.85, 1.55*1.55, 1.4*1.4};
	
		
	//float boxx, boxy, boxz;
	mat33f boxaxis;
	vec3f boxorg;
	float tempave, tempvar;
	int istep;


	int* knd = NULL;
	float* rx = NULL;
	float* ry = NULL;
	float* rz = NULL;
	vec3f* r = NULL;
	int* li = NULL;
	int* lj = NULL;
	float* Jij = NULL;
	char* bond = NULL;
	
	

	int flag_J;

	if(filepos != fp_pos){
		fseek64(fp, filepos, SEEK_SET);
	}

	if(fread64(&pcnt, sizeof(int), 1, fp) == 1){
		fread64(&bcnt, sizeof(int), 1, fp);
		fread64(&flag_J, sizeof(int), 1, fp);

		knd = new int[pcnt];
		rx = new float[pcnt];
		ry = new float[pcnt];
		rz = new float[pcnt];
		
		li = new int[bcnt];
		lj = new int[bcnt];
		bond = new char[bcnt];
		if(flag_J & FAD_FLAG_J){ Jij = new float[bcnt];}

		fread64(knd,	sizeof(char)*pcnt, 1, fp);
		fread64(rx,	sizeof(float)*pcnt, 1, fp);
		fread64(ry,	sizeof(float)*pcnt, 1, fp);
		fread64(rz,	sizeof(float)*pcnt, 1, fp);
		r = new vec3f[pcnt];
		for (i = 0; i < pcnt; i++){
			r[i].x = rx[i];
			r[i].y = ry[i];
			r[i].z = rz[i];
		}
		delete [] rx; rx = NULL;
		delete [] ry; ry = NULL;
		delete [] rz; rz = NULL;

		fread64(li,	sizeof(int)*bcnt, 1, fp);
		fread64(lj,	sizeof(int)*bcnt, 1, fp);

		if(flag_J & FAD_FLAG_J){
			fread64(Jij, sizeof(float)*bcnt, 1, fp);
		
			for(i=0;i<bcnt;i++){
				if(Jij[i] < 0.0){
					int dmyi = li[i];
					li[i] = lj[i];
					lj[i] = dmyi;
					Jij[i] = - (Jij[i]);
				}
				if (Jmax < Jij[i]) {Jmax=Jij[i];}
			}
		}
		
		for(i=0;i<bcnt;i++){
			xx = rx[li[i]] - rx[lj[i]];
			yy = ry[li[i]] - ry[lj[i]];
			zz = rz[li[i]] - rz[lj[i]];
			rr = xx * xx + yy*yy + zz*zz;
			if (rr <= bondmax[(knd[li[i]] & 0x01) + (knd[lj[i]] & 0x01)] ){
				bond[i] = 1;
			}else{
				bond[i] = 0;
			}
		}

		if (flag_J & FAD_FLAG_SIMBOX) { //simbox̎w肪
			if (flag_J & FAD_FLAG_NONORTHOGONALBOX){//ɂsimboxw.
				
			}else{
				boxaxis.Clear();
				fread64(&(boxaxis.m11),	sizeof(float), 1, fp);
				fread64(&(boxaxis.m22),	sizeof(float), 1, fp);
				fread64(&(boxaxis.m33),	sizeof(float), 1, fp);
				boxorg.x = - 0.5f * boxaxis.m11;
				boxorg.y = - 0.5f * boxaxis.m22;
				boxorg.z = - 0.5f * boxaxis.m33;
			}
		}else{
			boxaxis.Clear();
			boxorg.Clear();
		}
		
		if(flag_J & FAD_FLAG_TEMPERATURE){
			fread64(&tempave,	sizeof(float), 1, fp);
			fread64(&tempvar,	sizeof(float), 1, fp);
		}else{
			tempave = tempvar = 0.0;
		}
		if(flag_J & FAD_FLAG_STEP){
			fread64(&istep,	sizeof(int), 1, fp);
		}else{
			istep = -1;
		}
		
		if(a==NULL){
			a = new ATOMS_DATA;
		}
		//a->no=mcnt;
		
		a->pcnt=pcnt;
		a->bcnt=bcnt;
		a->boxaxis=boxaxis;
		a->boxorg=boxorg;
		a->tempave = tempave;
		a->tempvar = tempvar;
		a->no = -1;
		a->istep = istep;

		a->knd = knd;
		//a->rx = rx;
		//a->ry = ry;
		//a->rz = rz;
		a->r = r;
		if(flag_J & FAD_FLAG_J){
			a->Jij = Jij;
		}else{
			a->Jij = NULL;
		}
		//a->bond = bond;
		a->bondInsideCnt = bcnt;
		a->info = NULL;

		if(m_maxAtomCount < pcnt){ m_maxAtomCount = pcnt;}
		if(m_maxBondCount < bcnt){ m_maxBondCount = bcnt;}
		//long64 ll = ftell64(fp);
		//a->prev = a->next = NULL;
		//printf("model %d, particle %d, bond %d\n",mcnt,pcnt,bcnt);
		return a;
	}
	
	return NULL;

}



ATOMS_DATA* MDLoader::readFrameFAD(FILE64* fp, long64 filepos){
	//ǂݍݐFMDLoaderԂ
	//sFNULLԂ
	//t@CI[œǂ߂ȂƂFNULLԂ

	ATOMS_DATA *a = new ATOMS_DATA;
	
	int i;//,j,dmyi;
	int pcnt,bcnt;
	float rr;
	vec3f r_ij;
	const float bondmax[] = {2.0f*2.0f, 1.8f*1.8f, 1.7f*1.7f};//{1.85*1.85, 1.55*1.55, 1.4*1.4};
	
		
	//float boxx, boxy, boxz;
	mat33f boxaxis;
	vec3f boxorg;
	float tempave, tempvar;
	int istep,no;
	int fortsize;	//binary data has header of array size in fortran
	float realtm;

	int* knd = NULL;
	//int* knd_sub = NULL;
	int* id = NULL;
	vec3f* r = NULL;
	vec3f* p = NULL;
	int* li = NULL;
	int* lj = NULL;
	float* Jij = NULL;
	char* bond = NULL;
	

	int flag_J;

	if(filepos != fp_pos){
		fseek64(fp, filepos, SEEK_SET);
	}


	if(fread64(&fortsize, sizeof(int), 1, fp) == 1){
		fread64(&pcnt, sizeof(int), 1, fp);
		fread64(&bcnt, sizeof(int), 1, fp);
		fread64(&flag_J, sizeof(int), 1, fp);
			fread64(&fortsize, sizeof(int), 1, fp);

		knd = new int[pcnt];
		float* fbuf = new float[pcnt];
		
		if(bcnt>0){
			li = new int[bcnt];
			lj = new int[bcnt];
			bond = new char[bcnt];
			if(flag_J & FAD_FLAG_J){Jij = new float[bcnt];}
		}
		
		
		
			fread64(&fortsize, sizeof(int), 1, fp);
		fread64(knd, sizeof(int)*pcnt, 1, fp);
			fread64(&fortsize, sizeof(int), 1, fp);
		
		
		
		if(flag_J & FAD_FLAG_ATOMEXT){
			id = new int[pcnt];
				fread64(&fortsize, sizeof(int), 1, fp);
			fread64(id,	sizeof(int) * pcnt, 1, fp);
				fread64(&fortsize, sizeof(int), 1, fp);
		}


		r = new vec3f[pcnt];

			fread64(&fortsize, sizeof(int), 1, fp);
		fread64(fbuf,	sizeof(float)*pcnt, 1, fp);
			fread64(&fortsize, sizeof(int), 1, fp);
		float* fi = fbuf;
		for (vec3f* ri = r; ri != r + pcnt; ri++){
			ri->x = *fi;
			fi++;
		}

			fread64(&fortsize, sizeof(int), 1, fp);
		fread64(fbuf,	sizeof(float)*pcnt, 1, fp);
			fread64(&fortsize, sizeof(int), 1, fp);
		fi = fbuf;
		for (vec3f* ri = r; ri != r + pcnt; ri++){
			ri->y = *fi;
			fi++;
		}

			fread64(&fortsize, sizeof(int), 1, fp);
		fread64(fbuf,	sizeof(float)*pcnt, 1, fp);
			fread64(&fortsize, sizeof(int), 1, fp);
		fi = fbuf;
		for (vec3f* ri = r; ri != r + pcnt; ri++){
			ri->z = *fi;
			fi++;
		}	
		
			
		if(flag_J & FAD_FLAG_ATOMEXT){
				
			p = new vec3f[pcnt];

				fread64(&fortsize, sizeof(int), 1, fp);
			fread64(fbuf,	sizeof(float)*pcnt, 1, fp);
				fread64(&fortsize, sizeof(int), 1, fp);
			fi = fbuf;
			for (vec3f* pi = p; pi != p + pcnt; pi++){
				pi->x = *fi;
				fi++;
			}

				fread64(&fortsize, sizeof(int), 1, fp);
			fread64(fbuf,	sizeof(float)*pcnt, 1, fp);
				fread64(&fortsize, sizeof(int), 1, fp);
			fi = fbuf;
			for (vec3f* pi = p; pi != p + pcnt; pi++){
				pi->y = *fi;
				fi++;
			}

				fread64(&fortsize, sizeof(int), 1, fp);
			fread64(fbuf,	sizeof(float)*pcnt, 1, fp);
				fread64(&fortsize, sizeof(int), 1, fp);
			fi = fbuf;
			for (vec3f* pi = p; pi != p + pcnt; pi++){
				pi->z = *fi;
				fi++;
			}	
	
		}
		delete [] fbuf;


		if(bcnt>0){
			if( m_flags & MDL_FLAG_READBOND ){	//bondǂޏꍇ.
					fread64(&fortsize, sizeof(int), 1, fp);
				fread64(li,	sizeof(int)*bcnt, 1, fp);
					fread64(&fortsize, sizeof(int), 1, fp);
					fread64(&fortsize, sizeof(int), 1, fp);
				fread64(lj,	sizeof(int)*bcnt, 1, fp);
					fread64(&fortsize, sizeof(int), 1, fp);
					
				

				if(flag_J & FAD_FLAG_J){
						fread64(&fortsize, sizeof(int), 1, fp);
					fread64(Jij, sizeof(float)*bcnt, 1, fp);
						fread64(&fortsize, sizeof(int), 1, fp);

					for(i=0;i<bcnt;i++){
						if(Jij[i] < 0.0){
							int dmyi = li[i];
							li[i] = lj[i];
							lj[i] = dmyi;
							Jij[i] = - (Jij[i]);
						}
						if (Jmax < Jij[i]) {Jmax=Jij[i];}
					}
				}
					
			
				for(i=0;i<bcnt;i++){
					li[i]--;lj[i]--;
					r_ij = r[li[i]] - r[lj[i]];
					rr = r_ij * r_ij;
					if (rr <= bondmax[(knd[li[i]] & 0x01) + (knd[lj[i]] & 0x01)] ){
						bond[i] = 1;
					}else{
						bond[i] = 0;
					}
				}
			}else{//bondǂݔ΂.
				
				long64 skipsz = sizeof(int) * 5;	//wb_[
				skipsz += sizeof(int) * 2 + sizeof(int)*pcnt;	//knd
				
				if(flag_J & FAD_FLAG_ATOMEXT){
					skipsz += sizeof(int) * 2 + sizeof(int)*pcnt;	//id
				}
				
				skipsz += (sizeof(int) * 2 + sizeof(float)*pcnt ) * 3;	//rx,ry,rz

				if(flag_J & FAD_FLAG_ATOMEXT){
					skipsz += (sizeof(int) * 2 + sizeof(float)*pcnt ) * 3;	//px,py,pz
				}

				skipsz += (sizeof(int) * 2 + sizeof(int)*bcnt ) * 2;	//li,lj
				if(flag_J & FAD_FLAG_J){
					skipsz += sizeof(int) * 2 + sizeof(float)*bcnt;		//Jij
				}

				fseek64(fp, filepos + skipsz, SEEK_SET);
				bcnt = 0;


			}

		}

		if (flag_J & FAD_FLAG_SIMBOX) { //simbox̎w肪
			if (flag_J & FAD_FLAG_NONORTHOGONALBOX){//ɂsimboxw.
				
					fread64(&fortsize, sizeof(int), 1, fp);
				fread64(&boxaxis,	sizeof(float) * 9, 1, fp);
				fread64(&boxorg,	sizeof(float) * 3, 1, fp);
				//fread64(&boxz,	sizeof(float), 1, fp);
					fread64(&fortsize, sizeof(int), 1, fp);
			}else{
				boxaxis.Clear();
					fread64(&fortsize, sizeof(int), 1, fp);
				fread64(&(boxaxis.m11),	sizeof(float), 1, fp);
				fread64(&(boxaxis.m22),	sizeof(float), 1, fp);
				fread64(&(boxaxis.m33),	sizeof(float), 1, fp);
					fread64(&fortsize, sizeof(int), 1, fp);


				boxorg.x = - 0.5f * boxaxis.m11;
				boxorg.y = - 0.5f * boxaxis.m22;
				boxorg.z = - 0.5f * boxaxis.m33;
					
			}
		}else{
			boxaxis.Clear();
			boxorg.Clear();
		}
		
		if(flag_J & FAD_FLAG_TEMPERATURE){
				fread64(&fortsize, sizeof(int), 1, fp);
			fread64(&tempave,	sizeof(float), 1, fp);
			fread64(&tempvar,	sizeof(float), 1, fp);
				fread64(&fortsize, sizeof(int), 1, fp);
		}else{
			tempave = tempvar = 0.0;
		}
		if(flag_J & FAD_FLAG_STEP){
				fread64(&fortsize, sizeof(int), 1, fp);
				if (fortsize==8){
					fread64(&no,	sizeof(int), 1, fp);
					fread64(&istep,	sizeof(int), 1, fp);
					realtm = ((float)istep) * 5E-18f;
				}else{
					fread64(&no,	sizeof(int), 1, fp);
					fread64(&istep,	sizeof(int), 1, fp);
					fread64(&realtm,sizeof(float), 1, fp);
				}
				fread64(&fortsize, sizeof(int), 1, fp);
		}else{
			no = istep = -1;
		}
		
		if(a==NULL){
			a = new ATOMS_DATA;
		}
		//a->no=mcnt;
		
		a->pcnt=pcnt;
		a->bcnt=bcnt;
		a->boxaxis=boxaxis;
		a->boxorg = boxorg;
		a->tempave = tempave;
		a->tempvar = tempvar;
		a->no = no;
		a->istep = istep;
		a->realtm = realtm;
		
		a->knd = knd;
		a->id = id;
		//a->rx = rx;
		//a->ry = ry;
		//a->rz = rz;
		a->r = r;
		//a->px = px;
		//a->py = py;
		//a->pz = pz;
		a->p = p;
		if(flag_J & 0x1){
			a->Jij = Jij;
		}else{
			a->Jij = NULL;
		}
		//a->bond = bond;
		a->bondInsideCnt = 0;
		a->info = NULL;

		if(m_maxAtomCount < pcnt){ m_maxAtomCount = pcnt;}
		if(m_maxBondCount < bcnt){ m_maxBondCount = bcnt;}
		//long64 ll = ftell64(fp);
		//a->prev = a->next = NULL;
		//printf("model %d, particle %d, bond %d\n",mcnt,pcnt,bcnt);

		return a;
	}
	
	return NULL;

}


long64 MDLoader::skipFrameFAD(FILE64* fp, long64 filepos){
	//ǂݍݐF݂̃t@C|C^Ԃ
	//sFLONG64_ZEROԂ
	//t@CI[œǂ߂ȂƂFLONG64_ZEROԂ

	int skipsz = 0;
	int pcnt,bcnt;
	
		
	int fortsize;	//binary data has header of array size in fortran

	int flag_J;

	if(filepos != fp_pos){
		fseek64(fp, filepos, SEEK_SET);
	}


	if(fread64(&fortsize, sizeof(int), 1, fp) == 1){
		fread64(&pcnt, sizeof(int), 1, fp);
		fread64(&bcnt, sizeof(int), 1, fp);
		fread64(&flag_J, sizeof(int), 1, fp);
			fread64(&fortsize, sizeof(int), 1, fp);
		
		skipsz = sizeof(int) * 5;	//wb_[
		skipsz += sizeof(int) * 2 + sizeof(int)*pcnt;	//knd
		
		if(flag_J & FAD_FLAG_ATOMEXT){
			skipsz += sizeof(int) * 2 + sizeof(int)*pcnt;	//id
		}

		
		skipsz += (sizeof(int) * 2 + sizeof(float)*pcnt ) * 3;	//rx,ry,rz

		if(flag_J & FAD_FLAG_ATOMEXT){
			skipsz += (sizeof(int) * 2 + sizeof(float)*pcnt ) * 3;	//px,py,pz
		}

		if(bcnt>0){
			skipsz += (sizeof(int) * 2 + sizeof(int)*bcnt ) * 2;	//li,lj
			
			if(flag_J & FAD_FLAG_J){
				skipsz += sizeof(int) * 2 + sizeof(float)*bcnt;		//Jij
			}
		}

		if(flag_J & FAD_FLAG_SIMBOX){
			if (flag_J & FAD_FLAG_NONORTHOGONALBOX){//ɂsimboxw.
				skipsz += sizeof(int) * 2 + sizeof(mat33f) + sizeof(vec3f);	//boxaxis,boxorg
			}else{
				skipsz += sizeof(int) * 2 + sizeof(float) * 3;	//boxx,boxy,boxz
			}
		}
		
		if(flag_J & FAD_FLAG_TEMPERATURE){
			skipsz += sizeof(int) * 2 + sizeof(float) * 2;	//tempave,tempvar
		}
		
		if(flag_J & FAD_FLAG_STEP){
			skipsz += sizeof(int) * 2 + sizeof(float) * 2;	//no,istep	//t@C//
			//skipsz += sizeof(int) * 2 + sizeof(float) * 3;	no,istep,realtm
		}

		fseek64(fp, filepos + skipsz, SEEK_SET);
		return filepos + skipsz;
	}
	
	return LONG64_ZERO;
}



int MDLoader::readTXT(FILE *fp, int mode){

//	FILEPOS_LIST* fa;
//	FILEPOS_LIST* fb;
	ATOMS_DATA *a;
	ATOMS_DATA *readBuf= new ATOMS_DATA;

	int mcnt;
		
//	fb = NULL;
	mcnt = 0;
	Jmax = -1.0;

	readMode = 0;

	
	readBuf->pcnt = TXT_INITIAL_ATOM;
	readBuf->bcnt = TXT_INITIAL_BOND;



	readBuf->knd = new int[TXT_INITIAL_ATOM];
	//readBuf->rx = new float[TXT_INITIAL_ATOM];
	//readBuf->ry = new float[TXT_INITIAL_ATOM];
	//readBuf->rz = new float[TXT_INITIAL_ATOM];
	readBuf->r = new vec3f[TXT_INITIAL_ATOM];
	readBuf->Jij = new float[TXT_INITIAL_BOND];
//	readBuf->bond = new char[TXT_INITIAL_BOND];

	readBuf->no = 1;
	readBuf->info = NULL;
	
	switch(mode){
	case 3:
		a = readFramePDB(fp,readBuf);
		break;
	case 4:
		a = readFrameXYZ(fp,readBuf);
		break;
	case 5:
		a = readFrameMD2(fp,readBuf);
		break;
	default:
		return 0;
	}

	while(a){
		
/*
		fa = new FILEPOS_LIST;
		fa->prev = fb;
		if (fb) {fb->next = fa;}
		else{m_fpos_first=fa;}

		fa->atmdat = a;		
		//fa->pos = fp_pos;
		fa->pos = 0;
		if(fa->atmdat->no == -1){ fa->atmdat->no = mcnt;}


		fb=fa;
*/

		if(a->no == -1){ a->no = mcnt;}
		FRAME_POS frame;
		frame.filepos = fp_pos;
		frame.atmdat = a;
		frame.keep = 0;
		m_framev.push_back(frame);

		//pos = jumplen + sizeof(int) * 3;
		//fp_pos = ftell64(fp);

		//printf("model %d, particle %d, bond %d\n",mcnt,pcnt,bcnt);


//		if(mcnt % 1000 == 0 ){	printf("read now %d", mcnt);}
		mcnt ++;
		readBuf->no++;
//		if(fp_pos > READLIMIT){
//			//obt@[t
//			//rf̈
//			unknown_pos = fp_pos;
//			readMode = mode;			
//			break;
//		}

		switch(mode){
		case 3:
			a = readFramePDB(fp,readBuf);
			break;
		case 4:
			a = readFrameXYZ(fp,readBuf);
			break;
		case 5:
			a = readFrameMD2(fp,readBuf);
			break;
		}

	}

	if (m_unknown_pos) {
		//rf
		printf("buffer fulls halfway\n");
	}

	
//	stockCnt = mcnt;
//	stock = new FILEPOS_LIST*[stockCnt];
//	stockIdx = 0;
		
	printf("%d frame loaded\n",mcnt);
	
	return mcnt;
	
}


int MDLoader::readMD3(const TCHAR* filepath){

//	FILEPOS_LIST* fa;
//	FILEPOS_LIST* fb;
	
	//ATOMS_DATA *readBuf= new ATOMS_DATA;
	Jmax = -1.0;

	readMode = 0;


	

	MD3_Reader* md3 = new MD3_Reader();
	{
		int length = _tcslen(filepath);
		char* mbfpath = new char[length*2];
		TCharToMultiByte(mbfpath, filepath, length);
		int ierr = md3->Open(mbfpath);
		delete [] mbfpath;
		if( ierr != 0){
			printf("error: file cannot be opened\n");
			delete md3;
			return -2;
		}

	}
	
	int count = md3->GetParticleCount();
	int frame = 0;
	vec3d* atoms_r = NULL;
	int bufsize = 0;
	double boxaxisorg[12];

	while(count > 0){
		
		//obt@m//
		ATOMS_DATA *a = new ATOMS_DATA;
		a->pcnt = count;
		a->knd = new int[count];
		a->id = new int[count];
		a->r = new vec3f[count];

		//doubleobt@m//
		if(count > bufsize){
			delete [] atoms_r;
		
			bufsize = count;
			atoms_r = new vec3d[count];
		}

		//t@Cǂݍ//////////////////////////////////
		int res = md3->Read(a->knd, (double*)atoms_r, NULL, NULL, boxaxisorg, NULL);
		if(res != count){
			printf("%d frame error: %d particles were read.\n", frame, res);
			delete a;
			break;
		}

		/////////////////////////////////t@Cǂݍ//

		//cast double to float//
		for(int i = 0; i < count; i++){
			a->r[i] = atoms_r[i];
			a->id[i] = i;
		}

		for(int i = 0; i < 9; i++){
			a->boxaxis.elements[i] = (float)boxaxisorg[i];
		}
		a->boxorg.Clear();

		a->bcnt = 0;
		a->bonds = NULL;
		a->id = NULL;
		a->frame = frame;
		a->istep = frame;
		a->no = frame;
		a->Jij = NULL;
		a->p = NULL;
		
		FRAME_POS framepos;
		framepos.filepos = fp_pos;
		framepos.atmdat = a;
		framepos.keep = 0;
		m_framev.push_back(framepos);

		frame++;

		count = md3->GetParticleCount();

	}

	md3->Close();
	delete md3;
	delete [] atoms_r;
		
	printf("%d frame loaded\n",frame);
	
	return frame;
	
}



ATOMS_DATA* MDLoader::readFramePDB(FILE* fp, ATOMS_DATA* readBuf){
	
	char chbuf[256];
	char kndch[256];
	char line[256];

//	int dmyi;
	int pcnt,bcnt;
//	float rr,Jmax;
//	vec3f dr;
	const float bondmax[] = {2.0f*2.0f, 1.8f*1.8f, 1.7f*1.7f};//{1.85*1.85, 1.55*1.55, 1.4*1.4};
	
	int istep;
	short int* pkindint; 

	
	int* knd = readBuf->knd;
	//float* rx = readBuf->rx;
	//float* ry = readBuf->ry;
	//float* rz = readBuf->rz;
	vec3f* r = readBuf->r;
	float* Jij = readBuf->Jij;
//	char* bond = readBuf->bond;


	int flag_J;	//0: energy currentL, 1: 
	
	ATOMS_DATA *a;



	Jmax = -1.0;
	if(fgets(line,255,fp) == NULL){ return NULL;}
	if (strncmp(line,"MODEL",5) != 0){ return NULL;}

		sscanf(line,"%s %d",chbuf, &istep);
			flag_J = 0x8;

		pcnt = 0;
		bcnt=0;
		

		while (fgets(line,255,fp) != NULL){
			if(strncmp(line,"ENDMDL",6) == 0){break;}
			if(strncmp(line,"ATOM",4) == 0){
				sscanf(line,"%s%s%s%s %f %f %f",chbuf,chbuf,kndch,chbuf,
					&(r[pcnt].x), &(r[pcnt].y), &(r[pcnt].z));

				pkindint = (short int*)kndch;
				if (strcmp(kndch,"Cc") == 0){	//C_custom
					knd[pcnt] = 0;
				//}else if (strcmp(kndch,"H")==0){
				}else if (*pkindint == 72){
					knd[pcnt] = 1;
				}else if (strcmp(kndch,"He")==0){
					knd[pcnt] = 2;
				}else if (strcmp(kndch,"Li")==0){
					knd[pcnt] = 3;
				}else if (strcmp(kndch,"Be")==0){
					knd[pcnt] = 4;
				}else if (strcmp(kndch,"B")==0){
					knd[pcnt] = 5;
				}else if (strcmp(kndch,"C")==0){
					knd[pcnt] = 6;
				}else if (strcmp(kndch,"N")==0){
					knd[pcnt] = 7;
				}else if (strcmp(kndch,"O")==0){
					knd[pcnt] = 8;
				}else if (strcmp(kndch,"F")==0){
					knd[pcnt] = 9;
				}else if (strcmp(kndch,"N")==0){
					knd[pcnt] = 10;
				}else if (strcmp(kndch,"Na")==0){
					knd[pcnt] = 11;
				}else if (strcmp(kndch,"Mg")==0){
					knd[pcnt] = 12;
				}else if (strcmp(kndch,"Al")==0){
					knd[pcnt] = 13;
				}else if (strcmp(kndch,"Si")==0){
					knd[pcnt] = 14;
				}else if (strcmp(kndch,"P")==0){
					knd[pcnt] = 15;
				}else if (strcmp(kndch,"S")==0){
					knd[pcnt] = 16;
				}else if (strcmp(kndch,"Cl")==0){
					knd[pcnt] = 17;
				}else if (strcmp(kndch,"Ar")==0){
					knd[pcnt] = 18;
				}else if (strcmp(kndch,"K")==0){
					knd[pcnt] = 19;
				}else if (strcmp(kndch,"Ca")==0){
					knd[pcnt] = 20;
				}else{
					knd[pcnt] = 21;
				}

				pcnt ++ ;
				//obt@I[o[t[
				if (pcnt == readBuf->pcnt){
					
					readBuf->pcnt *= 4;
					
					renew(&knd, pcnt, readBuf->pcnt);
					renew((float**)&r, pcnt*3, readBuf->pcnt*3);
					
					readBuf->knd = knd;
					readBuf->r = r;
				}
/*
			}else if(strncmp(line,"CONECT",6) == 0){
				sscanf(line,"%s %d %d %f",chbuf,li + bcnt, lj + bcnt, Jij + bcnt);
				
				li[bcnt]--; lj[bcnt]--;
				if(Jij[bcnt] < 0.0){
					dmyi = li[bcnt];
					li[bcnt] = lj[bcnt];
					lj[bcnt] = dmyi;
					Jij[bcnt] = -Jij[bcnt];
				}
				if (Jmax < Jij[bcnt]) {Jmax=Jij[bcnt];}
					
				dr = r[li[bcnt]] - r[lj[bcnt]];
				rr = dr * dr;
				if (rr <= bondmax[(knd[li[bcnt]] & 0x01) + (knd[lj[bcnt]] & 0x01)] ){
					bond[bcnt] = 1;
				}else{
					bond[bcnt] = 0;
				}
				bcnt++;
				//obt@I[o[t[
				if (bcnt == readBuf->bcnt){
					
					readBuf->bcnt *= 4;
					
					renew(&li, bcnt, readBuf->bcnt);
					renew(&lj, bcnt, readBuf->bcnt);
					renew(&Jij, bcnt, readBuf->bcnt);
					renew(&bond, bcnt, readBuf->bcnt);

					readBuf->li = li;
					readBuf->lj = lj;
					readBuf->Jij = Jij;
					readBuf->bond = bond;


				}
				flag_J |= 0x1;
				*/
/*
			}else if(strncmp(line,"BOX",3) == 0){
				sscanf(line,"%s %f %f %f",chbuf,&(readBuf->boxaxis.x),&(readBuf->boxy),&(readBuf->boxz));
				flag_J |= 0x2;
			}else if(strncmp(line,"TEMP",4) == 0){
				sscanf(line,"%s %f %f",chbuf,&(readBuf->tempave),&(readBuf->tempvar));
				flag_J |= 0x4;
				*/
			}
			
		}
		


		//AI_atomdatɃRs[
		a = new ATOMS_DATA;
		
		a->pcnt=pcnt;
		a->bcnt=bcnt;
		a->boxaxis.Clear();
		a->boxorg.Clear();
		a->tempave = 0.0f;
		a->tempvar = 0.0f;
		a->no = readBuf->no;
		a->istep = istep;
		a->realtm = 0.0;
		
		a->knd = new int[pcnt];
		memcpy(a->knd, knd, sizeof(char) * pcnt);
		a->r = new vec3f[pcnt];
		memcpy(a->r, r, sizeof(vec3f) * pcnt);
		if(flag_J & 0x1){
			a->Jij = new float[bcnt];
			memcpy(a->Jij, Jij, sizeof(float) * bcnt);
		}else{
			a->Jij = NULL;
		}
		a->bondInsideCnt = bcnt;
		//a->bond = new char[bcnt];
		//memcpy(a->bond, bond, sizeof(char) * bcnt);
		a->info = NULL;

		if(m_maxAtomCount < pcnt){ m_maxAtomCount = pcnt;}
		if(m_maxBondCount < bcnt){ m_maxBondCount = bcnt;}

	return a;


}



ATOMS_DATA* MDLoader::readFrameXYZ(FILE* fp, ATOMS_DATA* readBuf){
	
	char kndch[256];
	char line[1024];

	int pcnt,bcnt;
	float Jmax;
	const float BOND_LENGTH_SQUARE = 2.0f*2.0f;
	

	
	int* knd = NULL;
	vec3f* r = NULL;
	float* Jij = readBuf->Jij;
	short int* pkindint; 

	
	ATOMS_DATA *a;



	Jmax = -1.0;
	if(fgets(line,1024,fp) == NULL){ return NULL;}
		sscanf(line,"%d", &pcnt);
		if(pcnt<=0){return NULL;}
		bcnt=0;

		
		if(fgets(line,1024,fp) == NULL){ return NULL;}
		//epictureƂtitle̓ǂݎ

		a = new ATOMS_DATA;
		a->knd = knd = new int[pcnt];
		a->r = r = new vec3f[pcnt];
		a->pcnt = pcnt;
		pcnt = 0;
		
		a->info = _strdup(line);

		while (fgets(line,1024,fp) != NULL){
			sscanf(line,"%s %f %f %f",kndch, &(r[pcnt].x), &(r[pcnt].y), &(r[pcnt].z));
			
			pkindint = (short int*)kndch;
			switch (*pkindint){
			case 0x6343:
			case 0x4343:
				knd[pcnt] = 0;
				break;
			case 'H':
			case 'h':
				knd[pcnt] = 1;
				break;
			case 0x6548:
			case 0x6568:
				knd[pcnt] = 2;
				break;
			case 0x694C:
			case 0x696C:
				knd[pcnt] = 3;
				break;
			case 0x6542:
			case 0x6562:
				knd[pcnt] = 4;
				break;
			case 'B':
			case 'b':
				knd[pcnt] = 5;
				break;
			case 'C':
			case 'c':
				knd[pcnt] = 6;
				break;
			case 'N':
			case 'n':
				knd[pcnt] = 7;
				break;
			case 'O':
			case 'o':
				knd[pcnt] = 8;
				break;
			case 'F':
			case 'f':
				knd[pcnt] = 9;
				break;
			case 0x654E:
			case 0x656E:
				knd[pcnt] = 10;
				break;
			case 0x614E:
			case 0x616E:
				knd[pcnt] = 11;
				break;
			case 0x674D:
			case 0x676D:
				knd[pcnt] = 12;
				break;
			case 0x6c41:
			case 0x6c61:
				knd[pcnt] = 13;
				break;
			case 0x6953:
			case 0x6973:
				knd[pcnt] = 14;
				break;
			case 'P':
			case 'p':
				knd[pcnt] = 15;
				break;
			case 'S':
			case 's':
				knd[pcnt] = 16;
				break;
			case 0x6C43:
			case 0x6C63:
				knd[pcnt] = 17;
				break;
			case 0x7241:
			case 0x7261:
				knd[pcnt] = 18;
				break;
			case 'k':
			case 'K':
				knd[pcnt] = 19;
				break;
			case 0x6145:
			case 0x6165:
				knd[pcnt] = 17;
				break;
			default:
				knd[pcnt] = 0;
			}
		
				pcnt ++ ;
				//obt@I[o[t[
				if (pcnt == a->pcnt){break;}
		}


		//AI_atomdatɃRs[		
		a->bcnt=bcnt;
		a->boxaxis = g_default_boxaxis;
		a->boxorg.Clear();
		a->tempave = 0.0f;
		a->tempvar = 0.0f;
		a->no = readBuf->no;
		a->istep = 0;
		a->realtm = 0.0;
		
		a->Jij = NULL;
		a->bondInsideCnt = bcnt;
//		a->bond = new char[bcnt];
//		memcpy(a->bond, bond, sizeof(char) * bcnt);

		if(m_maxAtomCount < pcnt){ m_maxAtomCount = pcnt;}
		if(m_maxBondCount < bcnt){ m_maxBondCount = bcnt;}

	return a;


}


ATOMS_DATA* MDLoader::readFrameMD2(FILE* fp, ATOMS_DATA* readBuf){
	
	char kndch[256];
	char line[1024];

	int pcnt,bcnt;
	float Jmax;
	const float BOND_LENGTH_SQUARE = 2.0f*2.0f;
	

	
	int* knd = NULL;
	vec3f* r = NULL;
	float* Jij = readBuf->Jij;
	short int* pkindint; 

	
	ATOMS_DATA *a;



	Jmax = -1.0;
	if(fgets(line,1024,fp) == NULL){ return NULL;}
		sscanf(line,"%d", &pcnt);
		if(pcnt<=0){return NULL;}
		bcnt=0;

		
		if(fgets(line,1024,fp) == NULL){ return NULL;}
		//epictureƂtitle̓ǂݎ

		a = new ATOMS_DATA;
		a->knd = knd = new int[pcnt];
		a->r = r = new vec3f[pcnt];
		a->pcnt = pcnt;
		pcnt = 0;
		
		a->info = _strdup(line);

		while (fgets(line,1024,fp) != NULL){
			int id = 0;
			sscanf(line,"%d %s %f %f %f", &id, kndch, &(r[pcnt].x), &(r[pcnt].y), &(r[pcnt].z));
			
			pkindint = (short int*)kndch;
			switch (*pkindint){
			case 0x6343:
			case 0x4343:
				knd[pcnt] = 0;
				break;
			case 'H':
			case 'h':
				knd[pcnt] = 1;
				break;
			case 0x6548:
			case 0x6568:
				knd[pcnt] = 2;
				break;
			case 0x694C:
			case 0x696C:
				knd[pcnt] = 3;
				break;
			case 0x6542:
			case 0x6562:
				knd[pcnt] = 4;
				break;
			case 'B':
			case 'b':
				knd[pcnt] = 5;
				break;
			case 'C':
			case 'c':
				knd[pcnt] = 6;
				break;
			case 'N':
			case 'n':
				knd[pcnt] = 7;
				break;
			case 'O':
			case 'o':
				knd[pcnt] = 8;
				break;
			case 'F':
			case 'f':
				knd[pcnt] = 9;
				break;
			case 0x654E:
			case 0x656E:
				knd[pcnt] = 10;
				break;
			case 0x614E:
			case 0x616E:
				knd[pcnt] = 11;
				break;
			case 0x674D:
			case 0x676D:
				knd[pcnt] = 12;
				break;
			case 0x6c41:
			case 0x6c61:
				knd[pcnt] = 13;
				break;
			case 0x6953:
			case 0x6973:
				knd[pcnt] = 14;
				break;
			case 'P':
			case 'p':
				knd[pcnt] = 15;
				break;
			case 'S':
			case 's':
				knd[pcnt] = 16;
				break;
			case 0x6C43:
			case 0x6C63:
				knd[pcnt] = 17;
				break;
			case 0x7241:
			case 0x7261:
				knd[pcnt] = 18;
				break;
			case 'k':
			case 'K':
				knd[pcnt] = 19;
				break;
			case 0x6145:
			case 0x6165:
				knd[pcnt] = 17;
				break;
/*			case 'w':
			case 'W':
				knd[pcnt] = 74;
				break;*/
			default:
				knd[pcnt] = 0;
			}
		
				pcnt ++ ;
				//obt@I[o[t[
				if (pcnt == a->pcnt){break;}
		}


		//AI_atomdatɃRs[		
		a->bcnt=bcnt;
		a->boxaxis = g_default_boxaxis;
		a->boxorg.Clear();
		a->tempave = 0.0f;
		a->tempvar = 0.0f;
		a->no = readBuf->no;
		a->istep = 0;
		a->realtm = 0.0;
		
		a->Jij = NULL;
		a->bondInsideCnt = bcnt;
//		a->bond = new char[bcnt];
//		memcpy(a->bond, bond, sizeof(char) * bcnt);

		if(m_maxAtomCount < pcnt){ m_maxAtomCount = pcnt;}
		if(m_maxBondCount < bcnt){ m_maxBondCount = bcnt;}

	return a;


}


ATOMS_DATA* MDLoader::readFrameMD3(FILE* fp, ATOMS_DATA* readBuf){
	
	char kndch[256];
	char line[1024];

	int pcnt,bcnt;
	float Jmax;
	const float BOND_LENGTH_SQUARE = 2.0f*2.0f;
	

	
	int* knd = NULL;
	vec3f* r = NULL;
	float* Jij = readBuf->Jij;
	short int* pkindint; 

	
	ATOMS_DATA *a;



	Jmax = -1.0;
	if(fgets(line,1024,fp) == NULL){ return NULL;}
		sscanf(line,"%d", &pcnt);
		if(pcnt<=0){return NULL;}
		bcnt=0;

		
		if(fgets(line,1024,fp) == NULL){ return NULL;}
		//epictureƂtitle̓ǂݎ

		a = new ATOMS_DATA;
		a->knd = knd = new int[pcnt];
		a->r = r = new vec3f[pcnt];
		a->pcnt = pcnt;
		pcnt = 0;
		
		a->info = _strdup(line);

		while (fgets(line,1024,fp) != NULL){
			int id = 0;
			sscanf(line,"%d %s %f %f %f", &id, kndch, &(r[pcnt].x), &(r[pcnt].y), &(r[pcnt].z));
			
			pkindint = (short int*)kndch;
			switch (*pkindint){
			case 0x6343:
			case 0x4343:
				knd[pcnt] = 0;
				break;
			case 'H':
			case 'h':
				knd[pcnt] = 1;
				break;
			case 0x6548:
			case 0x6568:
				knd[pcnt] = 2;
				break;
			case 0x694C:
			case 0x696C:
				knd[pcnt] = 3;
				break;
			case 0x6542:
			case 0x6562:
				knd[pcnt] = 4;
				break;
			case 'B':
			case 'b':
				knd[pcnt] = 5;
				break;
			case 'C':
			case 'c':
				knd[pcnt] = 6;
				break;
			case 'N':
			case 'n':
				knd[pcnt] = 7;
				break;
			case 'O':
			case 'o':
				knd[pcnt] = 8;
				break;
			case 'F':
			case 'f':
				knd[pcnt] = 9;
				break;
			case 0x654E:
			case 0x656E:
				knd[pcnt] = 10;
				break;
			case 0x614E:
			case 0x616E:
				knd[pcnt] = 11;
				break;
			case 0x674D:
			case 0x676D:
				knd[pcnt] = 12;
				break;
			case 0x6c41:
			case 0x6c61:
				knd[pcnt] = 13;
				break;
			case 0x6953:
			case 0x6973:
				knd[pcnt] = 14;
				break;
			case 'P':
			case 'p':
				knd[pcnt] = 15;
				break;
			case 'S':
			case 's':
				knd[pcnt] = 16;
				break;
			case 0x6C43:
			case 0x6C63:
				knd[pcnt] = 17;
				break;
			case 0x7241:
			case 0x7261:
				knd[pcnt] = 18;
				break;
			case 'k':
			case 'K':
				knd[pcnt] = 19;
				break;
			case 0x6145:
			case 0x6165:
				knd[pcnt] = 17;
				break;
/*			case 'w':
			case 'W':
				knd[pcnt] = 74;
				break;*/
			default:
				knd[pcnt] = 0;
			}
		
				pcnt ++ ;
				//obt@I[o[t[
				if (pcnt == a->pcnt){break;}
		}


		//AI_atomdatɃRs[		
		a->bcnt=bcnt;
		a->boxaxis.Clear();
		a->boxorg.Clear();
		a->tempave = 0.0f;
		a->tempvar = 0.0f;
		a->no = readBuf->no;
		a->istep = 0;
		a->realtm = 0.0;
		
		a->Jij = NULL;
		a->bondInsideCnt = bcnt;
//		a->bond = new char[bcnt];
//		memcpy(a->bond, bond, sizeof(char) * bcnt);

		if(m_maxAtomCount < pcnt){ m_maxAtomCount = pcnt;}
		if(m_maxBondCount < bcnt){ m_maxBondCount = bcnt;}

	return a;


}

void MDLoader::clearBuffer(){
	
	
	for( IT_FRAME_POS it = m_framev.begin(); it != m_framev.end(); it++){
		if (it->atmdat){
			DeleteFrame(it->atmdat);
			it->atmdat = NULL;
		}
	}
	//delete m_framev;
}


int MDLoader::goNext(){
	//1Ԃ
	ATOMS_DATA* dat;
//	FILEPOS_LIST* fa;
	
	if (readMode == -1){ return 0;}

	

	if(m_frameNo + 1 < (int)m_framev.size() ){
		//݂Aǂݍݍς݂ł
		m_frameNo++;
		return 1;
	}
	
	if(m_unknown_pos == LONG64_ZERO){
		//t@CI[
		return 0;
	}


	switch (readMode){
	case 1:
		dat = readFrameDAT(fp, m_unknown_pos);
		break;
	case 2:
		dat = readFrameFAD(fp, m_unknown_pos);
		break;
	case 0:
		return 0;
	}
	fp_pos = ftell64(fp);
	
	if (dat == NULL){
		//t@C̏I[
		m_unknown_pos = LONG64_ZERO;
		return 0;
	}
	
	//ȉ, ǂݍݐ
			
	FRAME_POS frame;
	frame.atmdat = dat;		
	frame.filepos = m_unknown_pos;
	m_unknown_pos = fp_pos;
	frame.keep = 0;
	m_framev.push_back(frame);
	
	//buffer̈ڍs
	UnloadStock();

	m_frameNo++;
	return 1;
	
}


int MDLoader::goNext(int num){
	int i;
	int res;
	ATOMS_DATA* dat;

	//printf("pointers %x, %x\n",(stockFPL[stockIdx]->atm)->istep, (stockFPL[stockIdx]->atm)->li);

	if(num<=0){return -1;}
	if (readMode == -1){ return 0;}

	for(i=0;i<num - 1;i++){
		
		if(m_frameNo + 1 < (int)m_framev.size() ){
			//݂
			m_frameNo++;
			
		}else{
			
			if(m_unknown_pos == LONG64_ZERO){
				//t@CI[
				return 0;
			}

			switch (readMode){
			case 1:
				dat = readFrameDAT(fp, m_unknown_pos);
				if( ! dat){
					m_unknown_pos = LONG64_ZERO;
					return 0;
				}
				break;
			case 2:
				fp_pos = skipFrameFAD(fp, m_unknown_pos);
				if ( fp_pos == LONG64_ZERO) {
					m_unknown_pos = LONG64_ZERO;
					return 0;
				}
				dat = NULL;
				break;
			case 0:
				return 0;
			}
				
			FRAME_POS frame;
			frame.atmdat = dat;		
			frame.filepos = m_unknown_pos;
			m_unknown_pos = fp_pos;
			frame.keep = 0;
			m_framev.push_back(frame);
					
			m_frameNo++;
		}
	}
	
	res = goNext();

	return res;
}

int MDLoader::goPrev(){
	if (readMode == -1){ return 0;}

	if(m_frameNo > 0){
		m_frameNo--;
		return 1;
	}
	return 0;
}


int MDLoader::goPrev(int num){

	if(num<=0){return -1;}
	if (readMode == -1){ return 0;}

	if(m_frameNo == 0){return 0;}
	m_frameNo-=num;
	if(m_frameNo < 0){
		m_frameNo = 0;
	}
	return 1;
}

void MDLoader::goFirst(){
	if (readMode == -1){ return;}
	
	m_frameNo = 0;
	
}

ATOMS_DATA* MDLoader::GetDataPointer(){
	if (readMode == -1){ return NULL;}

	if(m_framev[m_frameNo].atmdat == NULL){
		if(readMode>0){
			switch (readMode){
			case 1:
				m_framev[m_frameNo].atmdat = readFrameDAT(fp, m_framev[m_frameNo].filepos);
				break;
			case 2:
				m_framev[m_frameNo].atmdat = readFrameFAD(fp, m_framev[m_frameNo].filepos);
				break;
			}
			fp_pos = ftell64(fp);
				

			if(m_framev[m_frameNo].atmdat){
				//ǂ߂Ƃ({IɕKǂ߂邱ƂۏႳĂ͂)
				UnloadStock();
			}
		}
	}

	
	//{h̍ČvZ//
	if(m_bond_check){
		ATOMS_DATA* dat = m_framev[m_frameNo].atmdat;
		if(dat->bcnt == 0){
			AI_ResetBond(dat);
		}
	}

	return m_framev[m_frameNo].atmdat;
	
}

void MDLoader::KeepCurrentFrame(){
	m_framev[m_frameNo].keep = 1;

}


void MDLoader::openWriteFile(const TCHAR* filename){
	if(m_wfp){ return;}
	m_wfp = _tfopen(filename, _T("w"));
}

void MDLoader::writeFrameXYZ(){
	
	ATOMS_DATA* dat = m_framev[m_frameNo].atmdat;
	int i;
		
	int* knd = dat->knd;
	vec3f* r = dat->r;
	
	fprintf(m_wfp, "%d\n", dat->pcnt);
	fprintf(m_wfp, "TimeStep %d\n", dat->istep);
	
	for(i = 0; i < dat->pcnt; i++){

		switch (knd[i]){
		case 0:
			fprintf(m_wfp, "C\t");
			break;
		case 1:
			fprintf(m_wfp, "H\t");
			break;
		default:
			fprintf(m_wfp, "X\t");
		
		}	

		fprintf(m_wfp, "%12.6f\t%12.6f\t%12.6f\n", r[i].x, r[i].y, r[i].z);
		
	}

}

void MDLoader::closeWriteFile(){
	if(m_wfp == NULL){ return;}
	fclose(m_wfp);
	m_wfp = NULL;
}


int MDLoader::GetFrameNum(){
	return m_frameNo;
}

int MDLoader::SetFrameNum(int frameNo){
//w肵t[܂ŃWv.
//Ãt[̃f[^݂Ȃꍇɂ.
//݂̑ŏIt[܂ŃWvĎ~܂.
//߂lɂ͎ۂɈړt[NoÂ,
//ɂăt@C̍ŏIt[ɒBfł.

	int delta = frameNo - m_frameNo;
	if(delta > 0){
		goNext(delta);
	}else if(delta < 0){
		goPrev(-delta);
	}

	
	return m_frameNo;

}

void MDLoader::DeleteFrame(ATOMS_DATA *dat){
	
	if (dat){
		delete dat;
	}
}


void MDLoader::UnloadStock(){
	int i = 0;
	for (IT_FRAME_POS it = m_framev.begin(); it != m_framev.end(); it++){
		if( i != m_frameNo){
			if(it->atmdat){
				if(it->keep == 0){
					DeleteFrame(it->atmdat);
					it->atmdat = NULL;
					break;
				}
				
			}
		}
		i++;
	}
}

void MDLoader::SetFlags(int flag){
	m_flags = flag;
}
