// AtomRendererGL.h: AtomRendererGL NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#ifndef __MDLoader_h__
#define __MDLoader_h__

#pragma once

#include <stdio.h>
#include <vector>
using namespace std;

#include "vec3.h"
#include "mat33.h"
#include "io64.h"
#include "mod.h"

#define TXT_INITIAL_ATOM 4096
#define TXT_INITIAL_BOND 8192

const long64 READLIMIT = 4*1024*1024;	// 64M


#define KIND_ALL (255)
#define MDL_FLAG_READBOND	 (1)

struct SIMPLE_IJ{
	int i;
	int j;
};

class ATOMS_DATA {
public:
	int frame;	//ǂݍ񂾏0CNg
	int no;
	int pcnt;
	int bcnt;
	int istep;
	float realtm;
	mat33f boxaxis;
	vec3f boxorg;
	float tempave;
	float tempvar;
	int* knd;
	int* id;
	vec3f* r;
	vec3f* p;
	SIMPLE_IJ* bonds;
	float* Jij;
	int bondInsideCnt;	//EׂȂ{h̐.
	char* info;		//ɕȂǂɎgp
	//ATOMS_DATA* prev;
	//ATOMS_DATA* next;

	ATOMS_DATA() : 
		pcnt(0),
		bcnt(0),
		knd(NULL),
		id(NULL),
		r(NULL),
		p(NULL),
		bonds(NULL),
		Jij(NULL),
		bondInsideCnt(NULL),
		info(NULL)
		{	};

	virtual ~ATOMS_DATA(){
		delete [] this->knd;
		delete [] this->id;
		delete [] this->r;
		delete [] this->p;
		delete [] this->bonds;
		delete [] this->Jij;
//		delete [] this->bond;
		delete [] this->info;
	};

};

class MDLoader{
private:

	struct FRAME_POS{
		long64 filepos;
		ATOMS_DATA* atmdat;
		int keep;
	};

typedef vector<FRAME_POS>	V_FRAME_POS;
typedef vector<FRAME_POS>::iterator	IT_FRAME_POS;

	V_FRAME_POS m_framev;
	


	long64 m_unknown_pos;		//܂ǂݍ݂ĂȂt@Cpos. I[ĂȂLONG64_ZERO.
	//FILEPOS_LIST->next==NULL ̂Ƃ
	//	unknown_pos == LONG64_ZERO Ȃ, t@C
	//	unknown_pos != LONG64_ZERO Ȃ, ǂݍ݂
	//		ǂݍݎsȂ, t@CƂunknown_posLONG64_ZEROZbg
	//		ǂݍݐȂ, t@Cł͂Ȃ̂, Xgt, , unknown_posɐVt@C|C^Zbg.


	int readMode;//-1:not read, 0: Sēǂݍݍς, 1: datǂݍ, 2: fadǂݍ
	FILE64* fp;
	int m_frameNo;			//݂̓̃t[io[


	long64 fp_pos;		//ǂݍݎɃt@C|C^ȂfBXNwbhĐݒ肵Ȃ߂̔p
	
	FILE* m_wfp;		//OpenWriteFilep

	
	int m_maxAtomCount;
	int m_maxBondCount;
	int m_flags;		//{hǂނǂ̃tO.

	int m_bond_check;	//{hČvZ邩ǂflag//
	

	int readBIN(FILE64 *fp, int mode);
	ATOMS_DATA* readFrameDAT(FILE64* fp, long64 filepos);
	ATOMS_DATA* readFrameFAD(FILE64* fp, long64 filepos);
	long64 skipFrameFAD(FILE64* fp, long64 filepos);
	int readTXT(FILE *fp, int mode);
	ATOMS_DATA* readFramePDB(FILE* fp, ATOMS_DATA* readBuf);
	ATOMS_DATA* readFrameXYZ(FILE* fp, ATOMS_DATA* readBuf);
	ATOMS_DATA* readFrameMD2(FILE* fp, ATOMS_DATA* readBuf);
	int readMD3(const TCHAR* filepath);
	ATOMS_DATA* readFrameMD3(FILE* fp, ATOMS_DATA* readBuf);
	void clearBuffer();
	void DeleteFrame(ATOMS_DATA *dat);
	
	void Load(const TCHAR *filename);
	void UnloadStock();
	void KeepCurrentFrame();


	int goPrev();
	int goPrev(int num);
	

public:
	float Jmax;

	MDLoader(const TCHAR *filename);
	virtual ~MDLoader();
	int goNext();
	int goNext(int num);
	void goFirst();
	ATOMS_DATA* GetDataPointer();

	
	void openWriteFile(const TCHAR *filename);
	void writeFrameXYZ();
	void closeWriteFile();
	
	int GetFrameNum();
	int SetFrameNum(int frameNo);
	void SetFlags(int flag);

	void SetBondCheckFlags(int flag){
		m_bond_check = flag;
	};
/*
	void Rendering();

	void SetMode(int mode);
	void ClearVRAM();	
*/	
};





#endif // __MDLoader_h__

