
#include "glsprite.h"
#include "debugprint.h"

#pragma warning(disable : 4996)

glsprite::glsprite(){
	m_spr_fst = NULL;
	m_txt_fst = NULL;
}

glsprite::~glsprite(){
	
	ClearSprite();

	ReleaseTextureAll();
}

//==============================================================================
//eNX`̃XgǗ
//==============================================================================
TEXTURE_LIST* glsprite::FindTextureList(const TCHAR* filename){
	//t@Cl[ɁAǂݍݍς݂̃eNX`[擾
	//ȂꍇNULLԂ
	//ēǂݍݒ~Ƃ́At->referCNg

	TEXTURE_LIST* t = m_txt_fst;
	while (t){
		if(_tcscmp(t->filename, filename) == 0){
			return t;
		}
		t = t->next;
	}

	//ȂꍇNULLԂ
	return NULL;
}


TEXTURE_LIST* glsprite::AddTextureList(GLuint texture, int w, int h, const TCHAR* filename){
	//Xgɒǉ

	TEXTURE_LIST* t;

	//Listɒǉ
	if(m_txt_fst==NULL){
		t = m_txt_fst = new TEXTURE_LIST;
	}else{
		t = m_txt_fst;
		while(t->next){
			t = t->next;
		}
		t->next = new TEXTURE_LIST;
		t = t->next;
	}
	t->next = NULL;

	t->texture = texture;
	t->w = w;
	t->h = h;
	if(filename){
		t->filename = _tcsdup(filename);
	}else{
		t->filename = NULL;
	}
	t->refer = 1;
	return t;


}


void glsprite::ReferTexture(GLuint textureId){
	//eNX`̍폜
	//referfNgāA0ɂȂVRAM폜

	TEXTURE_LIST* t = m_txt_fst;
	while (t){
		if(t->texture == textureId){
			t->refer ++;
			break;

		}
		t = t->next;
	}

	return;

}

void glsprite::ReleaseTexture(GLuint textureId){
	//eNX`̍폜
	//referfNgāA0ɂȂVRAM폜

	
	TEXTURE_LIST* t = m_txt_fst;
	TEXTURE_LIST* old_t = NULL;
	while (t){
		if(t->texture == textureId){
			t->refer --;
			
			if( t->refer <= 0){	//eNX`폜				
				glDeleteTextures(1, &(t->texture));

				//Xg폜
				delete [] t->filename;
				if(old_t){
					old_t->next = t->next; 
				}else{//t = m_fst_txt̂͂
					m_txt_fst = t->next;
				}
				delete t;
			}
			
			break;

		}
		old_t = t;
		t = t->next;
	}

	return;

}


int glsprite::ReleaseTextureAll(){
	//SẴeNX`J
	//JԂ

	TEXTURE_LIST* t;
	int cnt = 0;

	while (m_txt_fst){
		t = m_txt_fst;
		m_txt_fst = m_txt_fst->next;

		glDeleteTextures(1, &(t->texture));
		delete t;

		cnt++;

	}
	//m_txt_fst = NULL;		//ȂĂ͂

	return cnt;
}

//==============================================================================
//eNX` Load ֐========================================================
//==============================================================================
GLuint glsprite::LoadTextureBMP(const TCHAR* fname){
	return tagLoadTextureAlphaBMP24(fname,0,0,0,255);
}


GLuint glsprite::LoadTextureAlphaBMP(const TCHAR* fname, BYTE red, BYTE green, BYTE blue){
	return tagLoadTextureAlphaBMP24(fname,red,green,blue,0);
}

GLuint glsprite::tagLoadTextureAlphaBMP24(const TCHAR* fname, BYTE red, BYTE green, BYTE blue, BYTE alpha){
	FILE *fp;
	BITMAPINFOHEADER bmih;
	BYTE* texturebuf;
	BYTE* newBuf;
	GLuint textureIdx;
	int resW,resH;

	//łɓǂݍłȂ`FbN
	TEXTURE_LIST *t = FindTextureList(fname);
	if( t ){
		t->refer ++;
		return t->texture;
	}


	//摜[h
	fp = _tfopen(fname,_T("rb"));
	if(fp == NULL){
		return (GLuint)-1;
	}

	readDIB(fp, &bmih, &texturebuf);
	fclose(fp);
	
	

	//摜[h
	glEnable(GL_TEXTURE_2D);
	glGenTextures(1 , &textureIdx);
	glBindTexture(GL_TEXTURE_2D , textureIdx);

	//]4oCgƂ,windibƎdlA32bitł͍
	glPixelStorei(GL_UNPACK_ALIGNMENT, 4);

	
	if(alpha==255){	//alpha255Ȃ瓧߂Ȃ
		
		//f[^tH[}bgԐւƕ2̗ݏ扻
		newBuf = convDIBtoGLTEX(&bmih, texturebuf, 3, &resW, &resH);
		if(newBuf){
			delete [] texturebuf;
			texturebuf = newBuf;
		}
		glTexImage2D(GL_TEXTURE_2D, 0, 3, resW, resH,
			0 , GL_RGB , GL_UNSIGNED_BYTE , texturebuf	);
		delete [] texturebuf;
		

	}else{	//alpha255ȉȂwF(red,green,blue)ɎwalphaZbg
		
		newBuf = convDIBtoGLTEX(&bmih, texturebuf, 4, &resW, &resH);
		if(newBuf){
			delete [] texturebuf;
			texturebuf = newBuf;
		}
		setGLTEXAlpha(newBuf, resW*resH*4, red, green, blue, alpha);
	
		glTexImage2D(GL_TEXTURE_2D, 0, 4, resW, resH,
			0 , GL_RGBA , GL_UNSIGNED_BYTE , newBuf	);		
		delete [] newBuf;

	}

	//̃p[^eeNX`Ƃɐݒ肵Ȃƕ\Ȃꍇ			
			glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST );
			glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST );
	//}eAJ[𖳎
			glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);

	glDisable(GL_TEXTURE_2D);

	//Listɒǉ
	AddTextureList(textureIdx, bmih.biWidth, bmih.biHeight, fname);

	return textureIdx;
	
}

/*
GLuint glsprite::LoadTexturePNG(const TCHAR* fname){
	BYTE* texturebuf;
	GLuint textureIdx;
	
	int resW,resH;

	//łɓǂݍłȂ`FbN
	TEXTURE_LIST *t = FindTextureList(fname);
	if( t ){
		t->refer ++;
		return t->texture;
	}

	//摜[h
	texturebuf = LoadPNGtoGLRGBA(fname,&resW, &resH);
	if (texturebuf == NULL) return 0;

	glEnable(GL_TEXTURE_2D);
	glGenTextures(1 , &textureIdx);
	if(textureIdx == 0){ return 0;}
	glBindTexture(GL_TEXTURE_2D , textureIdx);

	//]4oCgƂ,windibƎdlA32bitł͍
	glPixelStorei(GL_UNPACK_ALIGNMENT, 4);

	
	glTexImage2D(GL_TEXTURE_2D, 0, 4, resW, resH,
		0 , GL_RGBA , GL_UNSIGNED_BYTE , texturebuf);
	
	delete [] texturebuf;


	//̃p[^eeNX`Ƃɐݒ肵Ȃƕ\Ȃꍇ			
			glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST );
			glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST );
	//}eAJ[𖳎
			glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);

	glDisable(GL_TEXTURE_2D);

	
	AddTextureList(textureIdx, resW, resH, fname);

	return textureIdx;
	
}
*/

//==============================================================================
//spritep֐========================================================
//==============================================================================

void glsprite::ClearSprite(){
	SPRITE_LIST *s;
	while (m_spr_fst){
		s = m_spr_fst;
		m_spr_fst = m_spr_fst->next;
		delete s;
	}
	//m_spr_fst = NULL;		//ȂĂ͂
}



void glsprite::SetSprite(int destx, int desty, int destw, int desth, int srcx, int srcy, int srcw, int srch, GLuint textureId){
	SPRITE_LIST *s;

	//eNX`T
	TEXTURE_LIST *t = m_txt_fst;
	while(t){
		if(t->texture == textureId){	//݂
			break;
		}
		t = t->next;
	}
	if(t==NULL){ return;}	//݂Ȃ
			

	//Listɒǉ
	if(m_spr_fst==NULL){
		s = m_spr_fst = new SPRITE_LIST;
	}else{
		s = m_spr_fst;
		while(s->next){
			s = s->next;
		}
		s->next = new SPRITE_LIST;
		s = s->next;
	}
	
	s->destx = destx;
	s->desty = desty;
	s->destw = destw;
	s->desth = desth;
	s->srcx1 = (float)srcx/(float)(t->w);
	s->srcy1 = (float)srcy/(float)(t->h);
	s->srcx2 = (float)(srcx+srcw)/(float)(t->w);
	s->srcy2 = (float)(srcy+srch)/(float)(t->h);
	s->texture = textureId;
	s->next = NULL;

}


void glsprite::DrawSprite(){
	SPRITE_LIST *s;

	glColor3f(1,1,1);
	glEnable(GL_TEXTURE_2D);

	s = m_spr_fst;
	while (s){
		
		glBindTexture(GL_TEXTURE_2D , s->texture);

		glBegin(GL_QUADS);
			glTexCoord2f(s->srcx1, s->srcy1);
			glVertex2i(s->destx, s->desty);
			glTexCoord2f(s->srcx1, s->srcy2);
			glVertex2i(s->destx, s->desty + s->desth);
			glTexCoord2f(s->srcx2, s->srcy2);
			glVertex2i(s->destx + s->destw, s->desty + s->desth);
			glTexCoord2f(s->srcx2, s->srcy1);
			glVertex2i(s->destx + s->destw, s->desty);
		glEnd();
		s = s->next;
	}
	
	glDisable(GL_TEXTURE_2D);
}


void glsprite::DrawSpriteAlpha(){
	
		//glEnable(GL_ALPHA_TEST);
		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		
		DrawSprite();
		
		glDisable(GL_BLEND);
		//glDisable(GL_ALPHA_TEST);
		
}

int glsprite::GetTextureSize(GLuint textureId, int* pwidth, int* pheight){
	
	//textureT
	TEXTURE_LIST *t = m_txt_fst;
	while(t){
		if(t->texture == textureId){	//݂
			if(pwidth){ *pwidth = t->w;}
			if(pheight){ *pheight = t->h;}
			return textureId;
		}
		t = t->next;
	}

	return 0;
}
