
#ifndef __lmc_reader_h__
#define __lmc_reader_h__

#pragma once


#include <stdio.h>
typedef char LMC_INT;


struct LMC_EVENT{
	int grid_index;
	LMC_INT delta;
};

class LMC_Reader
{
private:


	struct ATOMIC_ELEMENT{
		char symbol[4];		//need to include '\0'//
	};

	FILE* m_fp;	//t@C
	//int m_state;	//0:wb_[ǂݍݑO,1:wb_[ǂݍݍς,2:t@C//
	int m_grid_x;
	int m_grid_y;
	int m_grid_z;
	double m_boxaxis[12];
	ATOMIC_ELEMENT m_elements[108];
	int m_num_elements;

	int m_state;
	double m_next_step_time;

	int ReadHeader();
	int GetDataIndex(const char* atomicsymbol, const ATOMIC_ELEMENT* elements, int num_elements);

public:


	LMC_Reader();
	virtual ~LMC_Reader();

	///////////////////////////////////////////////////////
	//t@CI[v.
	//
	int Open(const char* filepath);
	//
	//	I[vłƂ 0 Ԃ.
	//	ɕʂ̃t@CI[vς݂̏ꍇ -2 Ԃ.
	//	w肵t@CȂƂ -1 Ԃ.
	//	ǂݍ񂾃f[^ĂƂ -3Ԃ.
	//	
	/////////////////////////////////////////////////////////////


	///////////////////////////////////////////////////////
	//t@C.
	//
	void Close();
	//
	//	delete Ă̊֐ŌĂ΂.
	//
	///////////////////////////////////////////////////////////

	////////////////////////////////////////////////////////////////////////////////
	//t@Cǂݍ݂ĕKvȃf[^Ԃ.
	//
	void GetNumGrid(int* grid_x, int* grid_y, int* grid_z);
	//
	//	qԂ.
	//	Reaďɂ̊֐ĂԂƎ̃t[ɐi߂.
	//
	//
	///////////////////////////////////////////////////////////
	
	////////////////////////////////////////////////////////////////////////////////
	//t@Cǂݍ݂ĕKvȃf[^Ԃ.
	//
	int GetNumElements();
	//
	//	qԂ.
	//	Reaďɂ̊֐ĂԂƎ̃t[ɐi߂.
	//
	//
	///////////////////////////////////////////////////////////

	
	////////////////////////////////////////////////////////////////////////////////
	//t@Cǂݍ݂ĕKvȃf[^Ԃ.
	//
	void GetBoxSize(double* boxaxis);
	//
	//
	///////////////////////////////////////////////////////////

	////////////////////////////////////////////////////////////////////////////////
	//Ԃǂݍ
	//
	int ReadInitialGrid(LMC_INT* buffer);
	//
	//
	//
	////////////////////////////////////////////////////////////////////////////////

	////////////////////////////////////////////////////////////////////////////////
	//1Xebv̓ǂݍ//
	//
	int ReadStep(double* time, LMC_EVENT* events);
	//
	//  ߂l1XebṽCxg
	//  -1AĂt@CI[ŏI
	//
	//
	///////////////////////////////////////////////////////////////////////////////
	

};






#endif	//!__lmc_reader_h__
